diff --git a/web/pgadmin/misc/sql/static/js/sql.js b/web/pgadmin/misc/sql/static/js/sql.js
index 8402fa21..1caf048b 100644
--- a/web/pgadmin/misc/sql/static/js/sql.js
+++ b/web/pgadmin/misc/sql/static/js/sql.js
@@ -1,4 +1,4 @@
-define([
+define('misc.sql', [
   'sources/gettext', 'underscore', 'underscore.string', 'jquery', 'pgadmin.browser',
   'alertify', 'pgadmin.alertifyjs'
 ], function(gettext, _, S, $, pgBrowser, Alertify) {
@@ -8,6 +8,7 @@ define([
   if (pgBrowser.ShowNodeSQL.initialized) {
     return pgBrowser.ShowNodeSQL;
   }
+  var wcDocker = window.wcDocker;
 
   _.extend(pgBrowser.ShowNodeSQL, {
     init: function() {
@@ -17,6 +18,7 @@ define([
       this.initialized = true;
       _.bindAll(this, 'showSQL', 'sqlPanelVisibilityChanged');
 
+      var sqlPanels;
       this.sqlPanels = sqlPanels = pgBrowser.docker.findPanels('sql');
 
       // We will listend to the visibility change of the SQL panel
@@ -64,6 +66,7 @@ define([
        **/
       this.timeout && clearTimeout(this.timeout);
 
+      var that = this;
       this.timeout =  setTimeout(
         function() {
           var sql = '';
@@ -75,11 +78,11 @@ define([
                 treeHierarchy = node.getTreeNodeHierarchy(item);
 
             // Avoid unnecessary reloads
-            if (_.isEqual($(this.sqlPanels[0]).data('node-prop'), treeHierarchy)) {
+            if (_.isEqual($(that.sqlPanels[0]).data('node-prop'), treeHierarchy)) {
               return;
             }
             // Cache the current IDs for next time
-            $(this.sqlPanels[0]).data('node-prop', treeHierarchy);
+            $(that.sqlPanels[0]).data('node-prop', treeHierarchy);
 
             if (node.hasSQL) {
 
diff --git a/web/pgadmin/misc/statistics/static/js/statistics.js b/web/pgadmin/misc/statistics/static/js/statistics.js
index 1377c1eb..4b7c117f 100644
--- a/web/pgadmin/misc/statistics/static/js/statistics.js
+++ b/web/pgadmin/misc/statistics/static/js/statistics.js
@@ -1,5 +1,6 @@
-define([
-  'sources/gettext', 'underscore', 'underscore.string', 'jquery', 'pgadmin.browser', 'backgrid',
+define('misc.statistics', [
+  'sources/gettext', 'underscore', 'underscore.string', 'jquery',
+  'pgadmin.browser', 'backgrid',
   'alertify', 'sources/size_prettify'
 ], function(gettext, _, S, $, pgBrowser, Backgrid, Alertify, sizePrettify) {
 
@@ -341,7 +342,7 @@ define([
 
     __createSingleLineStatistics: function(data, prettifyFields) {
       var row = data['rows'][0],
-          columns = data['columns']
+          columns = data['columns'],
           res = [];
 
       this.columns = this.statistic_columns;
diff --git a/web/pgadmin/static/bundle/app.js b/web/pgadmin/static/bundle/app.js
new file mode 100644
index 00000000..e4d6c421
--- /dev/null
+++ b/web/pgadmin/static/bundle/app.js
@@ -0,0 +1,23 @@
+define('app', [
+  'babel-polyfill','pgadmin', 'browser_node', 'tools.datagrid'
+  ], function() {
+    var initializeModules = function(Object) {
+      for (var key in Object) {
+        var module = Object[key];
+        if (module.init && typeof module.init == 'function') {
+          module.init();
+        }
+        else if (module.Init && typeof module.Init == 'function') {
+          module.Init();
+        }
+      }
+    }
+
+    // Initialize modules registered to pgAdmin, pgAdmin.Browser and Tools object.
+    initializeModules(pgAdmin);
+    initializeModules(pgAdmin.Browser);
+    initializeModules(pgAdmin.Tools);
+
+    // create menus after all modules are initialized.
+    pgAdmin.Browser.create_menus();
+});
\ No newline at end of file
diff --git a/web/pgadmin/static/bundle/browser.js b/web/pgadmin/static/bundle/browser.js
new file mode 100644
index 00000000..cf3a9089
--- /dev/null
+++ b/web/pgadmin/static/bundle/browser.js
@@ -0,0 +1,5 @@
+define('browser_node',[
+ 'pgadmin.browser'
+], function(pgBrowser) {
+  pgBrowser.init();
+});
\ No newline at end of file
diff --git a/web/pgadmin/static/bundle/codemirror.js b/web/pgadmin/static/bundle/codemirror.js
new file mode 100644
index 00000000..6c3525b1
--- /dev/null
+++ b/web/pgadmin/static/bundle/codemirror.js
@@ -0,0 +1,18 @@
+import CodeMirror from 'codemirror/lib/codemirror';
+import 'codemirror/mode/sql/sql';
+import 'codemirror/addon/selection/mark-selection';
+import 'codemirror/addon/selection/active-line';
+import 'codemirror/addon/fold/foldcode';
+import 'codemirror/addon/fold/foldgutter';
+import 'codemirror/addon/hint/show-hint';
+import 'codemirror/addon/hint/sql-hint';
+import 'codemirror/addon/scroll/simplescrollbars';
+import 'codemirror/addon/dialog/dialog';
+import 'codemirror/addon/search/search';
+import 'codemirror/addon/search/searchcursor';
+import 'codemirror/addon/search/jump-to-line';
+import 'codemirror/addon/edit/matchbrackets';
+import 'codemirror/addon/edit/closebrackets';
+import 'pgadmin.sqlfoldcode';
+
+export default CodeMirror;
\ No newline at end of file
diff --git a/web/pgadmin/static/bundle/slickgrid.js b/web/pgadmin/static/bundle/slickgrid.js
index dd7f8708..60b0ee92 100644
--- a/web/pgadmin/static/bundle/slickgrid.js
+++ b/web/pgadmin/static/bundle/slickgrid.js
@@ -1,6 +1,4 @@
-import 'slickgrid/slick.grid.css';
-import 'slickgrid/slick-default-theme.css';
-import 'slickgrid/css/smoothness/jquery-ui-1.11.3.custom.css';
+import 'slickgrid/lib/jquery.event.drag-2.3.0';
 import 'slickgrid/slick.core';
 import 'slickgrid/slick.grid';
 import 'slickgrid/slick.dataview';
@@ -9,6 +7,5 @@ import 'slickgrid/slick.formatters';
 import 'slickgrid/plugins/slick.autotooltips';
 import 'slickgrid/plugins/slick.cellrangedecorator';
 import 'slickgrid/plugins/slick.cellrangeselector';
-import 'slickgrid/lib/jquery.event.drag-2.3.0';
 
 export default window.Slick;
\ No newline at end of file
diff --git a/web/pgadmin/static/js/alertify.pgadmin.defaults.js b/web/pgadmin/static/js/alertify.pgadmin.defaults.js
index 04cee3b0..d44a82ff 100644
--- a/web/pgadmin/static/js/alertify.pgadmin.defaults.js
+++ b/web/pgadmin/static/js/alertify.pgadmin.defaults.js
@@ -96,7 +96,7 @@ function(gettext, alertify, S) {
       if (contentType) {
         try {
           if (contentType.indexOf('application/json') == 0) {
-            resp = $.parseJSON(msg);
+            var resp = $.parseJSON(msg);
 
             if (resp.result != null && (!resp.errormsg || resp.errormsg == '') &&
                 onJSONResult && typeof(onJSONResult) == 'function') {
@@ -116,7 +116,8 @@ function(gettext, alertify, S) {
               });
               return;
           }
-        } catch (exc) {
+        } catch (e) {
+          alertify.alert().show().set('message', e.message).set('title', "Error");
         }
       }
       alertify.alert().show().set(
diff --git a/web/pgadmin/static/js/backform.pgadmin.js b/web/pgadmin/static/js/backform.pgadmin.js
index f6e63d86..dec01855 100644
--- a/web/pgadmin/static/js/backform.pgadmin.js
+++ b/web/pgadmin/static/js/backform.pgadmin.js
@@ -5,8 +5,7 @@
     define([
       'sources/gettext', 'underscore', 'underscore.string', 'jquery',
       'backbone', 'backform', 'backgrid', 'codemirror', 'pgadmin.backgrid',
-      'codemirror/mode/sql/sql', 'select2', 'codemirror/addon/edit/matchbrackets',
-      'codemirror/addon/edit/closebrackets'
+      'select2'
       ],
      function(gettext, _, S, $, Backbone, Backform, Backgrid, CodeMirror) {
       // Export global even in AMD case in case this script is loaded with
@@ -20,13 +19,11 @@
       $ = root.jQuery || root.$ || root.Zepto || root.ender,
       Backbone = require('backbone') || root.Backbone,
       Backform = require('backform') || root.Backform,
-      Backgrid = require('backgrid') || root.Backgrid;
-      CodeMirror = require('codemirror') || root.CodeMirror;
-      pgAdminBackgrid = require('pgadmin.backgrid');
+      Backgrid = require('backgrid') || root.Backgrid,
+      CodeMirror = require('codemirror') || root.CodeMirror,
       S = require('underscore.string'),
       gettext = require('sources/gettext');
     factory(root, gettext, _, S, $, Backbone, Backform, Backgrid, CodeMirror);
-
   // Finally, as a browser global.
   } else {
     factory(root, root.gettext, root._, root.s, (root.jQuery || root.Zepto || root.ender || root.$), root.Backbone, root.Backform, root.Backgrid, root.CodeMirror);
@@ -125,8 +122,8 @@
 
       if (deps && _.isArray(deps)) {
         _.each(deps, function(d) {
-          attrArr = d.split('.');
-          name = attrArr.shift();
+          var attrArr = d.split('.');
+          var name = attrArr.shift();
           self.listenTo(self.model, "change:" + name, self.render);
         });
       }
@@ -143,8 +140,8 @@
       if (deps && _.isArray(deps)) {
         _.each(deps, function(d) {
 
-          attrArr = d.split('.');
-          name = attrArr.shift();
+          var attrArr = d.split('.');
+          var name = attrArr.shift();
 
           self.stopListening(self.model, "change:" + name, self.render);
         });
@@ -807,7 +804,7 @@
 
         // Check if unique columns provided are also in model attributes.
         if (uniqueCol.length > _.intersection(columns, uniqueCol).length) {
-            errorMsg = "Developer: Unique columns [ "+_.difference(uniqueCol, columns)+" ] not found in collection model [ " + columns +" ]."
+            var errorMsg = "Developer: Unique columns [ "+_.difference(uniqueCol, columns)+" ] not found in collection model [ " + columns +" ]."
             alert (errorMsg);
         }
 
@@ -873,7 +870,7 @@
         if (newModel != model) {
           var duplicateAttrValues = []
           _.each(uniqueCol, function(attr) {
-            attrValue = newModel.get(attr);
+            var attrValue = newModel.get(attr);
             if (!_.isUndefined(attrValue) && attrValue == model.get(attr)) {
               duplicateAttrValues.push(attrValue)
             }
@@ -961,7 +958,7 @@
       this.control_data = _.clone(data);
 
       // Show Backgrid Control
-      grid = this.showGridControl(data);
+      var grid = this.showGridControl(data);
 
       this.$el.html(grid).addClass(field.name);
       this.updateInvalid();
@@ -1054,7 +1051,7 @@
       });
 
       // Render subNode grid
-      subNodeGrid = self.grid.render().$el;
+      var subNodeGrid = self.grid.render().$el;
 
       // Combine Edit and Delete Cell
       if (data.canDelete && data.canEdit) {
@@ -1062,7 +1059,7 @@
         $(subNodeGrid).find("th.pg-backform-edit").attr("colspan", "2");
       }
 
-      $dialog =  gridBody.append(subNodeGrid);
+      var $dialog =  gridBody.append(subNodeGrid);
 
       // Add button callback
       if (!(data.disabled || data.canAdd == false)) {
@@ -1179,7 +1176,7 @@
         canDelete: evalF(data.canDelete, data, this.model)
       });
       // Show Backgrid Control
-      grid = (data.subnode == undefined) ? "" : this.showGridControl(data);
+      var grid = (data.subnode == undefined) ? "" : this.showGridControl(data);
 
       // Clean up first
       this.$el.removeClass(Backform.hiddenClassname);
@@ -1229,7 +1226,7 @@
           gridHeader = ["<div class='subnode-header'>",
           "  <label class='control-label pg-el-sm-10'>" + data.label + "</label>" ,
           "  <button class='btn-sm btn-default add fa fa-plus'></button>",
-          "</div>"].join("\n");
+          "</div>"].join("\n"),
         gridBody = $("<div class='pgadmin-control-group backgrid form-group pg-el-xs-12 object subnode'></div>").append(gridHeader);
 
       var subnode = data.subnode.schema ? data.subnode : data.subnode.prototype,
@@ -1318,7 +1315,7 @@
       });
 
       // Render subNode grid
-      subNodeGrid = grid.render().$el;
+      var subNodeGrid = grid.render().$el;
 
       // Combine Edit and Delete Cell
       if (data.canDelete && data.canEdit) {
@@ -1326,7 +1323,7 @@
         $(subNodeGrid).find("th.pg-backform-edit").attr("colspan", "2");
       }
 
-      $dialog =  gridBody.append(subNodeGrid);
+      var $dialog =  gridBody.append(subNodeGrid);
 
       // Add button callback
       $dialog.find('button.add').click(function(e) {
@@ -1859,8 +1856,8 @@
 
       if (deps && _.isArray(deps)) {
         _.each(deps, function(d) {
-          attrArr = d.split('.');
-          name = attrArr.shift();
+          var attrArr = d.split('.'),
+            name = attrArr.shift();
           self.listenTo(self.model, "change:" + name, self.render);
         });
       }
@@ -2160,7 +2157,7 @@
       });
     },
     onSelect: function(ev) {
-      var dialog_type = this.field.get('dialog_type');
+      var dialog_type = this.field.get('dialog_type'),
           supp_types = this.field.get('supp_types'),
           btn_primary = this.field.get('btn_primary'),
           dialog_title = this.field.get('dialog_title'),
diff --git a/web/pgadmin/static/js/backgrid.pgadmin.js b/web/pgadmin/static/js/backgrid.pgadmin.js
index 39e44e6d..48ee98cd 100644
--- a/web/pgadmin/static/js/backgrid.pgadmin.js
+++ b/web/pgadmin/static/js/backgrid.pgadmin.js
@@ -3,36 +3,38 @@
   if (typeof define === 'function' && define.amd) {
     define([
       'sources/gettext', 'underscore', 'jquery', 'backbone', 'backform', 'backgrid', 'alertify',
-      'moment', 'bignumber', 'bootstrap.datetimepicker'
+      'moment', 'bignumber', 'bootstrap.datetimepicker', 'bootstrap.switch'
     ],
      function(gettext, _, $, Backbone, Backform, Backgrid, Alertify, moment, BigNumber) {
       // Export global even in AMD case in case this script is loaded with
       // others that may still expect a global Backform.
-      return factory(root, gettext, _, $, Backbone, Backform, Alertify, moment, BigNumber);
+      return factory(root, gettext, _, $, Backbone, Backform, Backgrid, Alertify, moment, BigNumber);
     });
 
   // Next for Node.js or CommonJS. jQuery may not be needed as a module.
   } else if (typeof exports !== 'undefined') {
-    var _ = require('underscore') || root._,
+    var gettext = require('sources/gettext'),
+      _ = require('underscore') || root._,
       $ = root.jQuery || root.$ || root.Zepto || root.ender,
       Backbone = require('backbone') || root.Backbone,
-      Backform = require('backform') || root.Backform;
-      Alertify = require('alertify') || root.Alertify;
+      Backform = require('backform') || root.Backform,
+      Backgrid = require('backgrid') || root.Backgrid,
+      Alertify = require('alertify') || root.Alertify,
       moment = require('moment') || root.moment;
-    factory(root, gettext, _, $, Backbone, Backform, Alertify, moment);
+    factory(root, gettext, _, $, Backbone, Backform, Backgrid, Alertify, moment);
 
   // Finally, as a browser global.
   } else {
-    factory(root, root.gettext, root._, (root.jQuery || root.Zepto || root.ender || root.$), root.Backbone, root.Backform);
+    factory(root, root.gettext, root._, (root.jQuery || root.Zepto || root.ender || root.$), root.Backbone, root.Backform, root.Alertify, root.moment);
   }
-} (this, function(root, gettext, _, $, Backbone, Backform, Alertify, moment, BigNumber) {
+} (this, function(root, gettext, _, $, Backbone, Backform, Backgrid, Alertify, moment, BigNumber) {
   /*
      * Add mechanism in backgrid to render different types of cells in
      * same column;
    */
 
   // Add new property cellFunction in Backgrid.Column.
-  _.extend(Backgrid.Column.prototype.defaults, { cellFunction: undefined });
+  _.extend(Backgrid.Column.prototype.defaults, {cellFunction: undefined});
 
   // Add tooltip to cell if cell content is larger than
   // cell width
@@ -213,7 +215,7 @@
     },
     postRender: function(model, column) {
       var editor = this,
-          el = this.el;
+          el = this.el,
           columns_length = this.columns_length;
 
       if (column != null && column.get("name") != this.column.get("name"))
@@ -229,7 +231,7 @@
       $dialog.find('div.subnode-body').append($form);
 
       // Call Backform to prepare dialog
-      back_el = $dialog.find('form.form-dialog');
+      var back_el = $dialog.find('form.form-dialog');
 
       this.objectView = new Backform.Dialog({
         el: back_el, model: this.model, schema: this.schema,
@@ -279,7 +281,7 @@
     // It's possible to render an option group or use a
     // function to provide option values too.
     optionValues: function() {
-      var res = [];
+      var res = [],
           opts = _.result(this.column.attributes, 'options');
       _.each(opts, function(o) {
         res.push([o.label, o.value]);
@@ -391,7 +393,7 @@
       },
       deleteRow: function (e) {
         e.preventDefault();
-        that = this;
+        var that = this;
         // We will check if row is deletable or not
         var canDeleteRow = (!_.isUndefined(this.column.get('canDeleteRow')) &&
                             _.isFunction(this.column.get('canDeleteRow')) ) ?
@@ -445,6 +447,7 @@
   /**
     SwitchCell renders a Bootstrap Switch in backgrid cell
   */
+  $.fn.bootstrapSwitch = jQuery.fn.bootstrapSwitch;
   var SwitchCell = Backgrid.Extension.SwitchCell = Backgrid.BooleanCell.extend({
     defaults: {
       options: _.defaults({
@@ -643,7 +646,7 @@
             ),
           selectTpl = _.template('<select <%=multiple ? "multiple" : "" %>></select>');
 
-      $select = self.$select = $(selectTpl({
+      var $select = self.$select = $(selectTpl({
         multiple: select2_opts.multiple
       })).appendTo(self.$el);
 
@@ -766,7 +769,7 @@
         "click": "addHeaderIcon"
       },
       addHeaderIcon: function (e) {
-        self = this;
+        var self = this,
         m = new (this.collection.model);
         this.collection.add(m)
         e.preventDefault();
@@ -873,7 +876,7 @@
           }, 10);
 
 
-        }},10);
+        } },10);
       return;
     }
   });
@@ -1006,7 +1009,7 @@
 
         if (deps && _.isArray(deps)) {
           _.each(deps, function(d) {
-            attrArr = d.split('.');
+            var attrArr = d.split('.'),
             name = attrArr.shift();
             self.listenTo(self.model, "change:" + name, self.dependentChanged);
           });
@@ -1019,8 +1022,8 @@
 
         if (deps && _.isArray(deps)) {
           _.each(deps, function(d) {
-            attrArr = d.split('.');
-            name = attrArr.shift();
+            var attrArr = d.split('.'),
+              name = attrArr.shift();
 
             self.stopListening(self.model, "change:" + name, self.dependentChanged);
           });
@@ -1357,9 +1360,9 @@
     },
     closeIt: function(ev) {
       var formatter = this.formatter,
-          model = this.model;
-          column = this.column;
-          val = this.$el.val();
+          model = this.model,
+          column = this.column,
+          val = this.$el.val(),
           newValue = formatter.toRaw(val, model);
 
       if (this.is_closing)
@@ -1397,7 +1400,7 @@
 
         this.render();
 
-        is_editable = _.isFunction(editable) ? !!editable.apply(column, [model]) : !!editable;
+        var is_editable = _.isFunction(editable) ? !!editable.apply(column, [model]) : !!editable;
         setTimeout(function() {
           self.$el.removeClass("editor");
           if (is_editable){ self.$el.addClass("editable"); }
diff --git a/web/pgadmin/static/js/check_node_visibility.js b/web/pgadmin/static/js/check_node_visibility.js
index ddd19906..18b6655c 100644
--- a/web/pgadmin/static/js/check_node_visibility.js
+++ b/web/pgadmin/static/js/check_node_visibility.js
@@ -30,7 +30,7 @@ define(['jquery', 'underscore', 'underscore.string'],
         return true;
       }
 
-      preference = pgBrowser.get_preference("browser", 'show_node_'+node_type);
+      var preference = pgBrowser.get_preference("browser", 'show_node_'+node_type);
 
       if (preference) {
         return preference.value
diff --git a/web/pgadmin/static/js/selection/clipboard.js b/web/pgadmin/static/js/selection/clipboard.js
index ac0dee50..ad84fdef 100644
--- a/web/pgadmin/static/js/selection/clipboard.js
+++ b/web/pgadmin/static/js/selection/clipboard.js
@@ -50,7 +50,6 @@ define(['sources/gettext', 'alertify'], function (gettext, alertify) {
          * called for each copy operation performed on any input/textarea from
          * this document.
          */
-        document.removeEventListener('copy', arguments.callee);
 
         var clipboardData = e.clipboardData || window.clipboardData;
 
diff --git a/web/pgadmin/static/js/selection/copy_data.js b/web/pgadmin/static/js/selection/copy_data.js
index 35259666..2f30dd70 100644
--- a/web/pgadmin/static/js/selection/copy_data.js
+++ b/web/pgadmin/static/js/selection/copy_data.js
@@ -7,7 +7,7 @@ define([
 ],
 function ($, _, clipboard, RangeSelectionHelper, rangeBoundaryNavigator) {
   var copyData = function () {
-    var self = this;
+    var self = this || window;
 
     var grid = self.slickgrid;
     var columnDefinitions = grid.getColumns();
diff --git a/web/pgadmin/static/js/slickgrid/event_handlers/handle_query_output_keyboard_event.js b/web/pgadmin/static/js/slickgrid/event_handlers/handle_query_output_keyboard_event.js
index 2a319407..50ebd471 100644
--- a/web/pgadmin/static/js/slickgrid/event_handlers/handle_query_output_keyboard_event.js
+++ b/web/pgadmin/static/js/slickgrid/event_handlers/handle_query_output_keyboard_event.js
@@ -8,14 +8,15 @@ function (copyData, RangeSelectionHelper) {
     var KEY_A = 65;
     var modifiedKey = event.keyCode;
     var isModifierDown = event.ctrlKey || event.metaKey;
-    this.slickgrid = args.grid;
+    var self = this || window;
+    self.slickgrid = args.grid;
 
     if (isModifierDown && modifiedKey == KEY_C) {
-      copyData.apply(this);
+      copyData.apply(self);
     }
 
     if (isModifierDown && modifiedKey == KEY_A) {
-      RangeSelectionHelper.selectAll(this.slickgrid);
+      RangeSelectionHelper.selectAll(self.slickgrid);
     }
   }
 });
\ No newline at end of file
diff --git a/web/pgadmin/static/js/slickgrid/slick.pgadmin.editors.js b/web/pgadmin/static/js/slickgrid/slick.pgadmin.editors.js
index 15b5fe9b..f3a28ddd 100644
--- a/web/pgadmin/static/js/slickgrid/slick.pgadmin.editors.js
+++ b/web/pgadmin/static/js/slickgrid/slick.pgadmin.editors.js
@@ -35,7 +35,7 @@
   // Generate and return editor buttons
   function getButtons(editable) {
     var $buttons = $("<div class='pg_buttons' />"),
-      label = editable ? 'Cancel': 'OK';
+      label = editable ? 'Cancel': 'OK',
       button_type = editable ? 'btn-danger' : 'btn-primary';
 
     if (editable) {
@@ -43,7 +43,7 @@
           .appendTo($buttons);
     }
 
-    $cancel_button = $("<button class='btn " + button_type + " fa fa-lg fa-times long_text_editor pg-alertify-button'>"+ label +"</button>")
+    var $cancel_button = $("<button class='btn " + button_type + " fa fa-lg fa-times long_text_editor pg-alertify-button'>"+ label +"</button>")
         .appendTo($buttons);
     return $buttons;
   }
@@ -119,7 +119,7 @@
 
   // Text data type editor
   function pgTextEditor(args) {
-    var $input, $wrapper;
+    var $input, $wrapper, $buttons;
     var defaultValue;
     var scope = this;
 
@@ -256,7 +256,7 @@
 
   // JSON data type editor
   function JsonTextEditor(args) {
-    var $input, $wrapper;
+    var $input, $wrapper, $buttons;
     var defaultValue;
     var scope = this;
 
@@ -379,7 +379,7 @@
 
   // Text data type editor
   function ReadOnlypgTextEditor(args) {
-    var $input, $wrapper;
+    var $input, $wrapper, $buttons;
     var defaultValue;
     var scope = this;
 
@@ -584,7 +584,7 @@
 
   // JSON data type editor
   function ReadOnlyJsonTextEditor(args) {
-    var $input, $wrapper;
+    var $input, $wrapper, $buttons;
     var defaultValue;
     var scope = this;
 
diff --git a/web/pgadmin/static/jsx/history/detail/code_mirror.jsx b/web/pgadmin/static/jsx/history/detail/code_mirror.jsx
index a2c3cae2..6f07e38c 100644
--- a/web/pgadmin/static/jsx/history/detail/code_mirror.jsx
+++ b/web/pgadmin/static/jsx/history/detail/code_mirror.jsx
@@ -8,8 +8,8 @@
 //////////////////////////////////////////////////////////////////////////
 
 import React from 'react';
-import $ from '../../../vendor/jquery/jquery-1.11.2';
-import code_mirror from '../../../vendor/codemirror/lib/codemirror';
+import $ from 'jquery';
+import code_mirror from 'sources/../bundle/codemirror';
 
 export default class CodeMirror extends React.Component {
 
diff --git a/web/pgadmin/static/jsx/history/detail/history_detail_query.jsx b/web/pgadmin/static/jsx/history/detail/history_detail_query.jsx
index 0ef63a0a..b3eab01f 100644
--- a/web/pgadmin/static/jsx/history/detail/history_detail_query.jsx
+++ b/web/pgadmin/static/jsx/history/detail/history_detail_query.jsx
@@ -8,7 +8,7 @@
 //////////////////////////////////////////////////////////////////////////
 
 import React from 'react';
-import '../../../vendor/codemirror/mode/sql/sql';
+import 'codemirror/mode/sql/sql';
 
 import CodeMirror from './code_mirror';
 import Shapes from '../../react_shapes';
diff --git a/web/pgadmin/static/jsx/history/query_history.jsx b/web/pgadmin/static/jsx/history/query_history.jsx
index 270dbf19..52806a63 100644
--- a/web/pgadmin/static/jsx/history/query_history.jsx
+++ b/web/pgadmin/static/jsx/history/query_history.jsx
@@ -102,4 +102,8 @@ export default class QueryHistory extends React.Component {
 
 QueryHistory.propTypes = {
   historyCollection: Shapes.historyCollectionClass.isRequired,
+};
+
+export {
+  QueryHistory,
 };
\ No newline at end of file
